#define BELL     '\a'		/* 0x07 */
#define TAB      '\t'		/* 0x09 */
#define LF       '\n'		/* 0x0a */
#define YENMARK  '\\'		/* 0x5c */
#define SLASH    '/'		/* 0x2f */
#define SPACE    ' '		/* 0x20 */
#define DBQUOTE  '\"'		/* 0x22 */
#define PERCENT  '%'		/* 0x25 */
#define RIGHTP   ')'		/* 0x29 */
#define COMMA    ','		/* 0x2c */
#define PERIOD   '.'		/* 0x2e */

#define FNAMEMAX 280	/* 256 + alpha */
#define MAXLINE  4099	/* max record length for input file + 3 */
							/* (1 for LF, 1 for NULL, and 1 for checking */
							/* record length of input file) */
#define MAXLINEOUT	16385	/* max record length for output file + 1 */
							/* (sufficiently large number) */
#define MAXLABEL 4096
#define LNAMEMAX 130	/* max length for label_name/string_for_length_spec */
						/* +2 (1 for NULL and 1 for possible '-') */
#define SAMPLERDOTS	100	/* number of dots to draw a sampler for -s option */

#define SRCEXT ".grp"
#define DESTEXT ".tex"
#define BAKEXT ".org"

#define DEFT0  0.0
#define DEFB0  0.0
#define DEFL0  0.0
#define DEFR0  0.0
#define DEFRA0 0.15
#define DEFRK0 0.08
#define DEFPP0 0.3
#define DEFPV0 0.2
#define DEFC0  0.2
#define DEFD0  0.1
#define DEFS0  0.6
#define DEFE0  0.14
#define DEFI0  0.1
#define DEFO0  0.1

#define NUMDIGIT 12 /* number of digits for numerals */

void scale( 
	char *line, char *label[], char *length[],
	int *D, int *ilab, int *ilength, int *flglabel,
	int *error, double *t, double *b, double *l, double *r, double *ra,
	double *s, double *xcur, double *ycur, double *xmax, double *ymax,
	double *xmin, double *ymin, double *xlab, double *ylab,
	char *lenval[]
) ;

void scsave(
	int i, char *line, double *xcur, double *ycur,
	int *ilab, char *label[], double *xlab, double *ylab,
	double *xmax, double *ymax, double *xmin, double *ymin,
	int *flglabel, int *error
) ;

void scmove(
	int i, char *line, char C, char *label[], int ilab,
	double *xlab, double *ylab, double *xcur, double *ycur,
	double *xmax, double *ymax, double *xmin, double *ymin,
	int ilength, char *length[], char *lenval[],
	int *error
) ;

void scsample(
	int i, char *line, int D, double s, double *xcur, double *ycur,
	double *xmax, double *ymax, double *xmin, double *ymin,
	int ilength, char *length[], char *lenval[], int prefix, int *error
) ;

void scadd(
	int i, char *line, int *ilab, char *label[],
	int *flglabel, double *xlab, double *ylab,
	double xcur, double ycur, double *xmax, double *ymax,
	double *xmin, double *ymin, double ra, int *error
) ;

void scline(
	int i, char *line, int d, char *label[],
	double *xlab, double *ylab, int ilab, double *xcur, double *ycur,
	double *xmax, double *ymax, double *xmin, double *ymin,
	int ilength, char *length[], char *lenval[], int prefix, int *error
) ;

void scgo(
	int i, char *line, char *label[], int ilab,
	double *xlab, double *ylab, double *xcur, double *ycur, int *error
) ;

void srlab(
	int *i, char *line, char *lab, int *error
) ;

void scbox(
	int i, char *line, int D, double *xcur, double *ycur,
	double *xmax, double *ymax, double *xmin, double *ymin,
	int ilength, char *length[], char *lenval[], int prefix, int *error
) ;

void srlen(
	int *i, char *line, char *len, int *comma,
	int *error, char next, int ilength, char *length[], char *lenval[]
) ;

void comment(
	int *i, char *line, char *lab, int *error
) ;

void minmax(
	double txmax, double tymax, double txmin, double tymin,
	double *xmax, double *ymax, double *xmin, double *ymin
) ;

void subparam(
	int i, char *line, char *len, int ilength, char *length[], char *lenval[],
	int *error, int prefix, double *p,
	double DEF
) ;

void scdir(
	int i, char *line, int *D, int *error
) ;

void sccomment(
	int i, char *line, int *error
) ;

void interpret(
	char *line, char *spacetab, char *tex, char *label[], int *D,
	int ilab,
	int *flglabel, int *error, double *t, double *b, double *l, double *r,
	double *ra,
	double *rk, double *pp, double *pv, double *c, double *db, double *s,
	double *de, double *di, double *doo,
	double *xcur, double *ycur, double *oldxcur, double *oldycur,
	double *xs, double *ys, double *xlab,
	double *ylab, int *ilength, char *length[], char *lenval[],
	int *helpline, int boldboxflag, int samplerflag
) ;

void texcom(
	int i, char *line, char *tex, double xcur, double ycur,
	int ilab, char *label[], double *xlab, double *ylab,
	int ilength, char *length[], char *lenval[], char *spacetab, int *error
) ;

void stfile(
	double xmax, double ymax, double xmin, double ymin, double t,
	double b, double l, double r, char *tex
) ;

void sample(
	int i, char *line, char *tex, int D, double s, double *xcur,
	double *ycur, double *xs, double *ys, double cs, int ilength,
	char *length[], char *lenval[], int prefix, int samplerflag, int *error
) ;

void subline(
	int v, char *xc, char *yc, char *xl, char *yl, char *len,
	char *tex
) ;

void dline(
	int dash, int v, int i, char *line, char *tex, int d, char *label[],
	int *flglabel, double *xlab, double *ylab,
	int ilab, double *xcur, double *ycur, double *xs, double *ys, double cs,
	double ra, double de, double di, double doo,
	int ilength, char *length[], char *lenval[],
	int prefix, int *error
) ;

void linep(
	double X, double x, char *xl, char *yl, char *len
) ;

void linev(
	double Y, double y, char *xl, char *yl, char *len
) ;

void add(
	int i, char *line, char *tex, int D,
	double xcur, double ycur, double *xs, double *ys, double cs, double ra,
	int *error
) ;

void circle(
	int c, double x, double y, double r, char *tex
) ;

void knot(
	int i, char *line, char *tex, double xcur, double ycur,
	double *xs, double *ys, double cs, int d, double rk, int *error
) ;

void box(
	int i, char *line, char *tex,int d, int D, double *xcur,
	double *ycur, double *xs, double *ys, double cs, double db,
	int ilength, char *length[], char *lenval[], int prefix,
	int boldboxflag, int *error
) ;

void pm(
	int m, int i, char *line, char *tex, int d, double pp, double pv,
	double xcur, double ycur, int *error
) ;

void wcomment(
	int i, char *line, char *tex, double cs, int D,
	double xs, double ys, int *error
) ;

void srpara(
	int i, char *line, char *len, int ilength, char *length[], char *lenval[],
	int *error
) ;

void param(
	int i, char *line, double *t, double *b, double *l, double *r,
	double *ra, double *s, double *rk, double *pp, double *pv, double *c,
	double *db, double *de, double *di, double *doo,
	int ilength, char *length[], char *lenval[],
	int flag, int prefix, int *error
) ;

void move(
	int i, char *line, char C, char *label[], int ilab,
	double *xlab, double *ylab, double *xcur, double *ycur,
	double *xs, double *ys, int ilength, char *length[], char *lenval[],
	int *error
) ;

void subcmove(
	int i, char *line, char C, char *label[], int ilab,
	double *xlab, double *ylab, double *xs, double *ys,
	int ilength, char *length[], char *lenval[], int *error
) ;

void go(
	int i, char *line, char *label[], int ilab,
	double *xlab, double *ylab, double *xcur, double *ycur,
	double *xs, double *ys, int D, double c, int *error
) ;

void dbox(
	int d, char *dblen, char *xc, char *yc, char *xl, char *yl,
	char *lab, char *tex, int boldboxflag
) ;

double value(
	double v
) ;

void config(
	char *line, double *DEFT, double *DEFB, double *DEFL,
	double *DEFR,
	double *DEFRA, double *DEFRK, double *DEFPP, double *DEFPV, double *DEFC,
	double *DEFD, double *DEFS, double *DEFE, double *DEFI, double *DEFO,
	int ilength, char *length[], char *lenval[],
	int *error
) ;

void setlen(
	int i, char *line, int *ilength, char *length[], char *lenval[],
	int *error
) ;
