#define OPENMSG "DiaGraph  .............  A Preprocessor for LaTeX"
#define VERSION "Ver. 1.25c" /* small bugs fixed on April 11, 1994 */
				/* and on December 16, 1997 */
#define COPYRIGHT "Copyright(C) 1990-2004 by T. Hagiwara and A. Toyoda"
				/* year modified on July 14, 2004 */
#define RESERVED "All rights reserved."
#define NOWARRANTY "This software is provided without any express or implied warranties."
#define NOLIABILITY "In no event shall the copyright holders be liable for any damages\narising in any way out of the use of this software."
				/* These two notices were added on July 14, 2004 */

#include <stdio.h>
#ifndef UNIX
#	include <stdlib.h>
#	include <process.h>
#	include <conio.h>
#	include <alloc.h>
#else
#	include <stdlib.h>
#endif
#include <string.h>
#include <ctype.h>
#include <math.h>
#include "diadefh.h"

#ifdef UNIX
#	define SEPARATOR SLASH
#else
#	define SEPARATOR YENMARK
#endif

double  DEFT  = DEFT0,  DEFB  = DEFB0,  DEFL = DEFL0, DEFR = DEFR0,
		DEFRA = DEFRA0,	DEFRK = DEFRK0,
		DEFPP = DEFPP0, DEFPV = DEFPV0, DEFC = DEFC0,
		DEFD  = DEFD0,  DEFS  = DEFS0,  DEFE = DEFE0, DEFI = DEFI0,
		DEFO  = DEFO0 ;

FILE *fp1, *fp2 ;

int main( int argc, char **argv )
{
	char *cnf, *env, *wkptr, *srcfl, *destfl, *destflbak, *cmd, *tex ;
	char **label, **length, **lenval, *line, *spacetab ;
#ifndef UNIX
	char *srcflbk ;
#endif
	int i, j, ilab = 0, ilength = 0 , D, error, retcode=0, helpflag=0,
		helpline, nonumflag=0, boldboxflag=0, samplerflag=0 ;
	int *flglabel ;
	double t, b, l, r, ra, rk, pp, pv, c, db, s, de, di, doo ;
	double xcur = 0, ycur = 0, xmax = 0, ymax = 0, xmin = 0, ymin = 0, xs, ys ;
	double oldxcur = 0, oldycur = 0 ;
    double *xlab, *ylab ;
	extern double DEFT, DEFB, DEFL, DEFR, DEFRA, DEFRK, DEFPP, DEFPV, DEFC,
		DEFD, DEFS, DEFE, DEFI, DEFO ;

		/* memory allocation */

	cnf = (char *)malloc( sizeof(char)*MAXLINE ) ;
	if ( cnf == NULL ) exit(1) ;
	srcfl = (char *)malloc( sizeof(char)*FNAMEMAX ) ;
	if ( srcfl == NULL ) exit(1) ;
	destfl = (char *)malloc( sizeof(char)*FNAMEMAX ) ;
	if ( destfl == NULL ) exit(1) ;
	destflbak = (char *)malloc( sizeof(char)*FNAMEMAX ) ;
	if ( destflbak == NULL ) exit(1) ;
	cmd = (char *)malloc( sizeof(char)*FNAMEMAX*2 ) ;
	if ( cmd == NULL ) exit(1) ;
	tex = (char *)malloc( sizeof(char)*MAXLINEOUT ) ;
	if ( tex == NULL ) exit(1) ;

	label = (char **)malloc( sizeof(char *)*MAXLABEL ) ;
	if ( label == NULL ) exit(1) ;
	for( j=0 ; j < MAXLABEL ; j++ )
		{
		label[j] = (char *)malloc( sizeof(char)*LNAMEMAX ) ;
		if ( label[j] == NULL ) exit(1) ;
		}

	length = (char **)malloc( sizeof(char *)*MAXLABEL ) ;
	if ( length == NULL ) exit(1) ;
	for( j=0 ; j < MAXLABEL ; j++ )
		{
		length[j] = (char *)malloc( sizeof(char)*LNAMEMAX ) ;
		if ( length[j] == NULL ) exit(1) ;
		}

	lenval = (char **)malloc( sizeof(char *)*MAXLABEL ) ;
	if ( lenval == NULL ) exit(1) ;
	for( j=0 ; j < MAXLABEL ; j++ )
		{
		lenval[j] = (char *)malloc( sizeof(char)*LNAMEMAX ) ;
		if ( lenval[j] == NULL ) exit(1) ;
		}

	line = (char *)malloc( sizeof(char)*MAXLINE ) ;
	if ( line == NULL ) exit(1) ;
	spacetab = (char *)malloc( sizeof(char)*MAXLINEOUT ) ;
	if ( spacetab == NULL ) exit(1) ;
#ifndef UNIX
	srcflbk = (char *)malloc( sizeof(char)*FNAMEMAX ) ;
	if ( srcflbk == NULL ) exit(1) ;
#endif

	flglabel = (int *)malloc( sizeof(int)*MAXLABEL ) ;
	if ( flglabel == NULL ) exit(1) ;
	xlab = (double *)malloc( sizeof(double)*MAXLABEL ) ;
	if ( xlab == NULL ) exit(1) ;
	ylab = (double *)malloc( sizeof(double)*MAXLABEL ) ;
	if ( ylab == NULL ) exit(1) ;

		/* opening message, version No., copyright notice */

	printf( "\n%s         %s\n%s\n%s\n%s\n%s\n\n",
					OPENMSG,VERSION,COPYRIGHT,RESERVED,NOWARRANTY,NOLIABILITY ) ;

		/* default values for \* commands */

	while( 1 )	/* only one execution of this loop */
		{
#ifdef UNIX
		if ( ( fp1 = fopen( ".diagraph", "rt" ) ) != NULL )
#else
		if ( ( fp1 = fopen( "diagraph.cnf", "rt" ) ) != NULL )
#endif
			{
			break ;   /* configuration file on current directory */
			}

		if ( ( env = getenv( "DIAGRAPH" ) ) != NULL )
			{
			strncpy( cnf, env, MAXLINE-13 ) ;
			if ( *( cnf+strlen( cnf )-1 ) != SEPARATOR )
				{
#ifdef UNIX
				strcat( cnf, "/" ) ;
#else
				strcat( cnf, "\\" ) ;
#endif
				}
#ifdef UNIX
			strcat( cnf, ".diagraph" ) ;
#else
			strcat( cnf, "diagraph.cnf" ) ;
#endif
			if ( ( fp1 = fopen( cnf, "rt" ) ) != NULL )
				{
				break ;   /* configuration file by environment variable */
				}
			}
		else
			{
			fp1 = NULL ;
			}

#ifndef UNIX
		strncpy( cnf, argv[0], MAXLINE-13 ) ;
		if ( ( wkptr = strrchr( cnf, SEPARATOR ) ) != NULL )
			{
			wkptr++ ;						/* if directory of diagraph.exe */
			strcpy( wkptr, "diagraph.cnf" ) ;	/* is known, configuration */
			fp1 = fopen( cnf, "rt" ) ;		/* file on the same directory */
			}
		else
			{                               
			fp1 = NULL ; /* directory of diagraph.exe is unknown */
			}
#endif
		break ;
		}

	if ( fp1 != NULL )
		{
		while( fgets( line, MAXLINE, fp1 ) != NULL )
			{
			error = 0 ;
			if ( strlen(line) > MAXLINE-2 )
				{
				error = 11 ;
				}
			else
				{
				config( line, &DEFT, &DEFB, &DEFL, &DEFR, &DEFRA, &DEFRK,
					&DEFPP, &DEFPV, &DEFC, &DEFD, &DEFS,
					&DEFE, &DEFI, &DEFO,
					ilength, length, lenval ,&error ) ;
				}
			if ( error != 0 ) retcode = 1 ;
			}
		fclose( fp1 ) ;
		if ( retcode != 0 ) printf( "Configuration file error\n\n" ) ;
		}


		/* set initial values by default */

	t = DEFT ; b = DEFB ; l = DEFL ; r = DEFR ; ra = DEFRA ; rk = DEFRK ;
	pp = DEFPP ; pv = DEFPV ; c = DEFC ; db = DEFD ; s = DEFS,
	de = DEFE; di = DEFI ; doo = DEFO ;


	if ( argc == 1 )
		{
		printf( "Usage:  diagraph [-option(s)] source_file_name\n" ) ;
#ifdef UNIX
		printf( "\n" ) ;
#endif
		exit(1) ;
		}
	else if ( argc >= 3 )
		{
		if ( (argc == 3) && (argv[1][0]=='-') )
			{
			for ( i = 1 ; i < strlen(argv[1]) ; i++ )
				{
				if ( argv[1][i] == 'h' )
					{
					helpflag = 1 ;
					}
				else if ( argv[1][i] == 'n' )
					{
					nonumflag = 1 ;
					}
				else if ( argv[1][i] == 'b' )
					{
					boldboxflag = 1 ;	/* only solid-lined boxes */
					}
				else if ( argv[1][i] == 'B' )
					{
					boldboxflag = 2 ;	/* solid- and dashed-lined boxes */
					}
				else if ( argv[1][i] == 's' )
					{
					samplerflag = 1 ;
					}
				else
					{
#ifndef UNIX
					printf( "%c", BELL ) ;
#endif
					printf( "Undefined option '%c' ignored.\n\n",
						argv[1][i] ) ;
					}
				}
			strncpy( srcfl, argv[2], FNAMEMAX-16 ) ;
			}
		else
			{
			printf( "Usage:  diagraph [-option(s)] source_file_name\n" ) ;
#ifdef UNIX
			printf( "\n" ) ;
#endif
			exit(1) ;
			}
		}
	else /* argc == 2 */
		{
		if ( (argv[1][0]=='-') && (argv[1][1]=='h') )
			{
			helpflag=1 ;
			}
		strncpy( srcfl, argv[1], FNAMEMAX-16 ) ;
		}

			/* completion of source file name */

		wkptr = strrchr( srcfl, PERIOD ) ;
		if ( ( wkptr ) == NULL )
			{
			strcat( srcfl, SRCEXT ) ;
			}
		else
			{
			if ( strchr( wkptr, SLASH ) != NULL ) strcat( srcfl, SRCEXT ) ;
			}
#ifndef UNIX
		strcpy( srcflbk, srcfl ) ; /* back up of srcfl */
		wkptr = srcfl ;
		while( ( wkptr = strchr( wkptr, SLASH ) ) != NULL )
			{
			*wkptr = YENMARK ; /* srcfl is with yenmark */
			}
#endif

			/* check existence and open */

		if ( ( fp1 = fopen( srcfl, "rt" ) ) == NULL )
			{
			if ( helpflag == 0 )
				{
				printf( "Specified source file not found.\n" ) ;
#ifdef UNIX
				printf( "\n" ) ;
#endif
				}
			exit(1);
			}
/*		printf( "Specified source file not found.\n" ) ;
		printf( "Enter DiaGraph source file name:  " ) ;
		scanf( "%s", srcfl ) ;
		printf( "\n" ) ;
		} */
#ifndef UNIX
	strcpy( srcfl, srcflbk ) ; /* srcfl is with slash */
#endif

	if ( ( wkptr = strrchr( srcfl, SLASH ) ) != NULL )
		{
		wkptr++ ;
		strcpy( destfl, wkptr ) ;      /* destination file is made on */
		strcpy( destflbak, wkptr ) ;   /* current directory           */
		}
#ifndef UNIX
	else if ( ( wkptr = strrchr( srcfl, ':' ) ) != NULL )
		{
		wkptr++ ;
		strcpy( destfl, wkptr ) ;      /* destination file is made on */
		strcpy( destflbak, wkptr ) ;   /* current directory           */
		}
#endif
	else 
		{
		strcpy( destfl, srcfl ) ;
		strcpy( destflbak, srcfl ) ;
		}
	wkptr = strrchr( destfl, PERIOD ) ;  /* always non-NULL */
	strcpy( wkptr, DESTEXT ) ;
	wkptr = strrchr( destflbak, PERIOD ) ;
	strcpy( wkptr, BAKEXT ) ;


	if ( ( fp2 = fopen( destfl, "r" ) ) != NULL )
		{
		fclose( fp2 ) ;

#ifndef UNIX
		printf( "%c", BELL ) ;
#endif

		printf( "File %s already exists.\n", destfl ) ;

		if ( ( fp2 = fopen( destflbak, "r" ) ) == NULL )
			{
#ifdef UNIX
			strcpy( cmd, "/bin/cp " ) ;
#else
			strcpy( cmd, "copy " ) ;
#endif

			strcat( cmd, destfl ) ;
			strcat( cmd, " " ) ;
			strcat( cmd, destflbak ) ;

#ifdef UNIX
			strcat( cmd, " > /dev/null" ) ;
			system( cmd ) ;
			printf( "Original %s backed up in %s.\n", destfl, destflbak ) ;
			printf( "\n" ) ;
#else
			strcat( cmd, " > nul" ) ;

			while( 1 )		/* only one execution of this loop */
				{
				if ( ( env = getenv( "COMSPEC" ) ) != NULL )
					{
					if ( ( fp2 = fopen( env, "r" ) ) != NULL )
						{
						fclose( fp2 ) ;
						system( cmd ) ;
						printf(
							"Original %s backed up in %s.\n", destfl, destflbak ) ;
						break ;			/* successful */
						}
					}
				printf( "COMMAND.COM not found.\n" ) ;
				printf( "Backing up of original %s failed.\n", destfl ) ;
				printf( "DiaGraph aborted.\n" ) ;
				exit(1) ;				/* unsuccessful */
				}
#endif
			}
		else
			{
			printf( "Backup file %s already exists; no further backup of %s created.\n", destflbak, destfl ) ;
			printf( "\n" ) ;
			}
		}

	/*	START OF CHECKING DiaGraph SOURCE FILE  */


	D = 0 ;		/* Initial value of current direction */
				/* D = 0 :  right
				       1 :  up
					   2 :  left
					   3 :  down */

    i = 0 ;

	printf( "Checking DiaGraph source file:  " ) ;
	while( fgets( line, MAXLINE, fp1 ) != NULL )
		{
        i++ ;
		if ( strlen(line) > MAXLINE-2 )
			{
			error = 11 ;
			}
		else
			{
			scale( line, label, length, &D, &ilab, &ilength, flglabel, &error,
				&t, &b, &l, &r,
				&ra, &s, &xcur, &ycur, &xmax, &ymax, &xmin, &ymin,
				xlab, ylab, lenval ) ;
			}
        if ( error==1 ) printf( "\nSyntax error in [%d]\n", i ) ;
        if ( error==2 ) printf( "\nLength specification error in [%d]\n",
								i ) ;


		if ( error==3 ) printf( "\nMemory for coordinate labels exhausted in [%d]\n",
				i ) ;
		if ( error==8 ) printf( "\nMemory for numerical labels exhausted in [%d]\n",
				i ) ;
		if ( error==9 ) printf( "\nToo long label name in [%d]\n", i ) ;
		if ( error==10 ) printf( "\nToo long string for length specification in [%d]\n", i ) ;
		if ( error==11 ) printf( "\nToo long line in input file at [%d]\n", i ) ;
		if ( error==4 || error==5 || error==7 ) printf( " in [%d]\n", i ) ;
		if ( error==-1)
			{
			error = 0 ;
			printf( " in [%d]\n", i ) ;
			}
		if ( error!=0 ) retcode=1 ;
		if ( nonumflag == 0 )
			{
			printf( "[%d]", i );
			}
		}
	if ( nonumflag == 0 )
		{
		printf( "\n\n" );
		}
	else
		{
		printf( "(%d lines)\n\n", i );
		}

#ifdef UNIX
	fp2 = fopen( destfl, "wt" ) ;
#else
	if ( ( fp2 = fopen( destfl, "wt" ) ) == NULL )
		{
		printf( "Destination file cannot be created.\nUse / for delimiters instead of %c.\n", YENMARK );
		exit(1) ;
		}
#endif


	/*	START OF GENERATING LaTeX SOURCE FILE  */


	rewind( fp1 ) ;
	ilength = 0 ; /* Initialize counter for length */
	D = 0 ;		/* Initial value of current direction */

		/* set initial values by default */

	ra = DEFRA ; rk = DEFRK ;
	pp = DEFPP ; pv = DEFPV ; c = DEFC ; db = DEFD ; s = DEFS ;
	de = DEFE  ; di = DEFI  ; doo = DEFO ;

	xcur = -xmin ; ycur = -ymin ; /* Initial value of current coordinate */

	for( i = 0 ; i < ilab ; i++ )
		{
		xlab[i] = xlab[i] + xcur ;  /* modify coordinates of */
		ylab[i] = ylab[i] + ycur ;  /* labeled points        */
		}
	xs = xcur ; ys = ycur ; /* Initial value of sub-current coordinate */

	printf( "Generating LaTeX source file:  " ) ;

	stfile( xmax, ymax, xmin, ymin, t, b, l, r, tex ) ;
	fputs( tex, fp2 ) ;

    i = 0 ;
	while( fgets( line, MAXLINE, fp1 ) != NULL )
		{
        i++ ;
		helpline = 0 ;
		if ( strlen(line) > MAXLINE-2 )
			{
			error = 11 ;
			}
		else
			{
			interpret( line, spacetab, tex, label, &D, ilab, flglabel, &error,
				&t, &b, &l, &r, &ra, &rk, &pp, &pv, &c, &db, &s,
				&de, &di, &doo,
				&xcur, &ycur,
				&oldxcur, &oldycur,
				&xs, &ys, xlab, ylab, &ilength, length, lenval, &helpline,
				boldboxflag, samplerflag ) ;
			}
        if( error==1 ) printf( "\nSyntax error in [%d]\n",i ) ;
        if( error==2 ) printf( "\nLength specification error in [%d]\n",
								i ) ;
		if( error==3 ) printf( "\nMemory for coordinate labels exhausted in [%d]\n",
				i ) ;
		if( error==8 ) printf( "\nMemory for numerical labels exhausted in [%d]\n",
				i ) ;
		if ( error==9 ) printf( "\nToo long label name in [%d]\n", i ) ;
		if ( error==10 ) printf( "\nToo long string for length specification in [%d]\n", i ) ;
		if ( error==11 ) printf( "\nToo long line in input file at [%d]\n", i ) ;
		if( error==4 || error==5 || error == 7 ) printf( " in [%d]\n", i ) ;
		if( error==6 ) printf( "\nDirection specification error in [%d]\n",
				i ) ;
		if ( error==-1)
			{
			error = 0 ;
			printf( " in [%d]\n", i ) ;
			}
		if( error!= 0 ) retcode=1 ;

		if( error==1 || error==4 || error==7 )
									/* line feed for syntax error etc. */
			{
			tex[0]=LF ;
			tex[1]='\0' ;
			}
		strcat( spacetab, tex ) ;
		strcpy( tex, spacetab ) ;
		fputs( tex, fp2 ) ;

			/* output line number and current direction */
			/* at the new current position updated by */
			/* execution of the DiaGraph command */

		if ( ( helpflag == 1 ) && ( helpline == 1 ) )
			{
			strcpy( tex, "\\put(" ) ;
			gcvt(value(xcur), NUMDIGIT,spacetab) ;
			strcat( tex, spacetab ) ; /* temporary use */
						/* of spacetab */
			strcat( tex, "," ) ;
			gcvt(value(ycur),NUMDIGIT,spacetab) ;
			strcat( tex, spacetab ) ;
			strcat( tex, "){\\makebox(0,0)[" ) ;
			if(D==0)
				{
				strcat(tex,"b") ;
				}
			else if(D==1)
				{
				strcat(tex,"r") ;
				}
			else if(D==2)
				{
				strcat(tex,"t") ;
				}
			else if(D==3)
				{
				strcat(tex,"l") ;
				}
			strcat( tex, "]{\\scriptsize " ) ;
			gcvt(value((double)i),(int)log10((double)i)+1,
				spacetab) ;
			strcat( tex, spacetab ) ;
			if(D==0)
				{
				strcat(tex,"$ r $") ;
				}
			else if(D==1)
				{
				strcat(tex,"$ u $") ;
				}
			else if(D==2)
				{
				strcat(tex,"$ \\ell $") ;
				}
			else if(D==3)
				{
				strcat(tex,"$ d $") ;
				}
			strcat( tex, "}}" ) ;
			fputs( tex, fp2 ) ;
			}

		if ( nonumflag == 0 )
			{
			printf( "[%d]",i ) ;
			}
		}
	if ( nonumflag == 1 )
		{
		printf( "(%d lines)", i );
		}

	strcpy( tex, "" ) ;
	strcat( tex, "\\end{picture}" ) ;
	line[0] = LF ;
	line[1] = '\0' ;
	strcat( tex, line ) ;
	fputs( tex, fp2 ) ;

	fclose( fp1 ) ;
	fclose( fp2 ) ;

	free( cnf ) ; free( srcfl ) ; free( destfl ) ; free( destflbak ) ;
	free( tex ) ; free( cmd ) ;
	for( j=0 ; j < MAXLABEL ; j++ )
		{
		free( label[j] ) ; free( length[j] ) ; free( lenval[j] ) ;
		}
	free( label ) ; free( length ) ; free( lenval ) ; free( line ) ;
	free( spacetab ) ; free( flglabel ) ; free( xlab ) ; free( ylab ) ;
#ifndef UNIX
	free( srcflbk ) ;
#endif

	if ( retcode != 0 )
		printf( "\n\nWarning:  DiaGraph ended unsuccessfully." ) ;
	printf( "\n" ) ;
#ifdef UNIX
	printf( "\n" ) ;
#endif
	exit( retcode ) ;
}
