#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include "diagraph.h"

void scadd(int i, char *line, int *ilab, char *label[],
	int *flglabel, double *xlab, double *ylab,
	double xcur, double ycur, double *xmax, double *ymax,
	double *xmin, double *ymin, double ra, int *error)
{
	char  *lab ;
	int j;

	lab=(char *)malloc( sizeof(char)*LNAMEMAX ) ;
	if( lab == NULL ) exit(1) ;

	i++;
	while(*(line+i)==SPACE || *(line+i)==TAB)
		{
		i++ ;
		}
	if(*(line+i)=='(')
		{
		srlab(&i, line, lab, error) ;
		if(*error==0)
			{
			if( *ilab >= MAXLABEL )
				{
				*error=3 ;
				free( lab ) ;
				return ;
				}
			for( j=0 ; j < *ilab ; j++ )
				{
				if( strcmp(label[j],lab)==0 )
					{
					printf( "\nMultiply defined label '%s'", lab ) ;
					*error=5 ;
					break ;
					}
				}
			strncpy(label[*ilab],lab,LNAMEMAX-1) ;
			flglabel[*ilab] = 1 ;
			xlab[*ilab] = xcur ;
			ylab[*ilab] = ycur ;
			minmax(xlab[*ilab]+ra,ylab[*ilab]+ra,xlab[*ilab]-ra,ylab[*ilab]-ra,
				xmax,ymax,xmin,ymin) ;
			(*ilab)++;
			}
		}
	else
		{
		*error=1 ;
		}
	free(lab);
}
