#include <stdio.h>
#ifndef UNIX
#	include <dos.h>
#	include <stdlib.h>
#else
#	include <stdlib.h>
#endif
#include <string.h>
#include "diagraph.h"

void scale( char *line, char *label[], char *length[],
	int *D, int *ilab, int *ilength, int *flglabel,
	int *error, double *t, double *b, double *l, double *r, double *ra,
	double *s, double *xcur,
	double *ycur, double *xmax, double *ymax, double *xmin, double *ymin,
	double *xlab, double *ylab, char *lenval[] )
{
	char C ;
	int i, flag, prefix ;
/************
	int j ;
***********/
	extern double DEFT, DEFB, DEFL, DEFR, DEFRA, DEFRK, DEFPP, DEFPV, DEFC,
		DEFD, DEFS, DEFE, DEFI, DEFO ;
	double rk = DEFRK, pp = DEFPP, pv = DEFPV, c = DEFC , db = DEFD,
		de = DEFE, di = DEFI, doo = DEFO ;

	*error = 0 ;
	prefix = 0 ;
	i = 0 ;
	while( *(line+i) == SPACE || *(line+i) == TAB )
		{
		i++;
		}

	C = *(line+i) ;

	if( C == '-' )
		{
		prefix = 1 ;
		i++;
		while( *(line+i) == SPACE || *(line+i) == TAB )
			{
			i++;
			}
		C = *(line+i) ;
		}

	if( C == LF || C == '\0' || C == PERCENT )
		{
		if (prefix==1) 	*error=1 ;
		}
	else if( C == 'c')
		{
		if (prefix==1)
			{
			*error=1 ;
			return ;
			}
		sccomment( i, line, error ) ;
		}
	else if( C == '$' )
		{
		if (prefix==1)
			{
			*error=1 ;
			return ;
			}
		setlen( i, line, ilength, length, lenval, error ) ;
		}
	else if( C == YENMARK ) /* change the parameter of figure */
		{
		flag = 0 ;
		/**** Error message for Length specification error
				is intentionally suppressed in the first phase. ****/
		/* flag = 0 ; */
		param( i, line, t, b, l, r, ra, s, &rk, &pp, &pv, &c, &db,
				&de, &di, &doo,
				*ilength, length, lenval, 
				flag, prefix, error ) ;
		}
	else if( C == 'n' || C == 'k' )
			  /* labeling/knot and saving the position */
		{
		if (prefix==1)
			{
			*error=1 ;
			return ;
			}
		scsave( i, line, xcur, ycur, ilab, label,
		       xlab, ylab, xmax, ymax, xmin, ymin,
		       flglabel, error ) ;
		}
	else if( C == 's' ) /* drawing a sampler */
		{
		scsample( i, line, *D, *s, xcur, ycur,
				xmax, ymax, xmin, ymin, *ilength, length, lenval,
				prefix, error ) ;
		}
	else if(C=='a')
		{
		if (prefix==1)
			{
			*error=1 ;
			return ;
			}
		scadd( i, line, ilab, label,
		      flglabel, xlab, ylab, *xcur, *ycur,
			  xmax, ymax, xmin, ymin, *ra, error ) ;
		}
	else if( C=='R' || C=='r' || C=='U' || C=='u' ||
	         C=='L' || C=='l' || C=='D' || C=='d' )
		{
		if( C=='R' || C=='r' ) *D=0 ;
		else if( C=='U' || C=='u' ) *D=1 ;
		else if( C=='L' || C=='l' ) *D=2 ;
		else if( C=='D' || C=='d' ) *D=3 ;

		scline( i, line, *D, label, xlab, ylab, *ilab,
				xcur, ycur, xmax, ymax, xmin, ymin, *ilength, length, lenval,
				prefix, error ) ;
		}

	else if( C=='m' || C=='p' )
		{
		i++;
		while( *(line+i)==SPACE || *(line+i)==TAB )
			{
			i++ ;
			}
		if( *(line+i)!=LF && *(line+i)!= PERCENT ) *error=1 ;
		if( *(line+i)==PERCENT && *(line+i+1)!=PERCENT ) *error=1 ;
		}

	else if( C=='g' )
		{
		if (prefix==1)
			{
			*error=1 ;
			return ;
			}
		scgo( i, line, label, *ilab, xlab, ylab, xcur, ycur, error ) ;
		}
	else if( C=='x' || C=='y' || C=='X' || C=='Y' )
		{
		if (prefix==1)
			{
			*error=1 ;
			return ;
			}
		scmove( i, line, C, label, *ilab, xlab, ylab, xcur, ycur,
				xmax, ymax, xmin, ymin, *ilength, length, lenval,
				error ) ;
		}
	else if( C=='B' || C=='b' )
		{
		scbox( i, line, *D, xcur, ycur,
				xmax, ymax, xmin, ymin, *ilength, length, lenval,
				prefix, error ) ;
		}
	else if( C=='t' )
		{
		if (prefix==1)
			{
			*error=1 ;
			return ;
			}
		scdir( i, line, D, error ) ;
		}
	else
		{
		*error=1 ;
		}

/**************
	printf("D=%d \n",*D);
	for(j=0;j<*ilab;j++)
		{
		printf("label[%d]='%s', flag=%d\n" ,j,label[j],flglabel[j]);
		printf("(x,y) of label=(%f,%f)\n",xlab[j],ylab[j]);
		}
	printf("ilab=%d \n",*ilab);
	printf("\\a=%f, \\k=%f, \\p=%f, \\v=%f, \\c=%f, \\d=%f, \\s=%f\n",
			*ra,rk,pp,pv,c,db,*s);
	printf("current (x,y)=(%f,%f) \n",*xcur,*ycur);
	printf("(xmax,ymax)=(%f,%f)\n",*xmax,*ymax);
	printf("(xmin,ymin)=(%f,%f)\n",*xmin,*ymin);
***************/
}
